﻿
Public Class Form1

    Private oldzoom As Double

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        EventsAreEnabled = False
        '
        Text = AppTitleAndVersion(True)
        ToolTips_Init()
        '
        Load_INI()
        LoadSlotNames()
        EnableDisableControls()
        oldzoom = txt_Zoom.NumericValue
        InitStringType()
        InitParams()
        ' ----------------------------------------------------------------
        Timer1.Interval = 15
        Timer1.Start()
        EventsAreEnabled = True
        ' ---------------------------------------------------------------- start UserInterface
        PanelControlsShowHide()
        Refresh()
        Me.Opacity = 1
        PanelDummy.Focus()
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        EventsAreEnabled = False
        Timer1.Stop()
        Save_INI()
    End Sub

    Private Sub Form_LocationChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LocationChanged
        If Not EventsAreEnabled Then Return
        LimitFormPosition(Me)
        Save_INI()
    End Sub

    Private Sub Form1_SizeChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.SizeChanged
        If Not EventsAreEnabled Then Return
        If Me.WindowState = FormWindowState.Minimized Then Return
        ' ----------------------------------------------------------------------------------------------
        ' This is a patch because the SizeChanged event sometimes is called without an effective change
        ' ----------------------------------------------------------------------------------------------
        Static oldsize As Size = New Size(0, 0)
        If Me.Size <> oldsize Then
            InitParams()
            Save_INI()
            oldsize = Me.Size
        End If
    End Sub

    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        If Not EventsAreEnabled Then Return

        If Me.WindowState = FormWindowState.Minimized Then
            Timer1.Stop()
            Return
        Else
            Timer1.Start()
        End If
        ' ----------------------------------------------------------------------------------------
        ' This is a patch because the Resize event sometimes is called without an effective change
        ' ----------------------------------------------------------------------------------------
        Static oldsize As Size = New Size(0, 0)
        If Me.Size <> oldsize Then
            LimitFormPosition(Me)
            InitParams()
            Save_INI()
            oldsize = Me.Size
        End If
    End Sub

    Private Sub PanelControlsShowHide()
        With Panel_Controls
            If .Visible Then
                .Location = New Point(4, 2)
                InitParams()
                SlotBars_Show()
            Else
                .Location = New Point(4 - .Width, 2 - .Height)
                InitParams()
                SlotBars_Show()
            End If
        End With
    End Sub

    ' =============================================================================
    '  PANEL CONTROLS SHOW HIDE  (the command MAXIMIZE is intercepted and removed)
    ' -----------------------------------------------------------------------------
    '  Window message WM_SYSCOMMAND (&H0112)
    '  A window receives &H0112 when the user press Window Menu commands 
    '  or when maximize, minimize, restore, or close buttons are pressed
    '  or when the window title area is double clicked 
    '  The wParam &HF020 is SC_MINIMIZE
    '  The wParam &HF030 is SC_MAXIMIZE
    '  The wParam &HF032 is MAXIMIZE with DOUBLE-CLICK
    ' =============================================================================
    <DebuggerStepThrough()> _
    Protected Overrides Sub WndProc(ByRef m As Message)
        If m.Msg = &H112 Then
            'Debug.Print(m.WParam.ToInt32.ToString)
            If m.WParam.ToInt32 = &HF030 Or m.WParam.ToInt32 = &HF032 Then
                Panel_Controls.Visible = Not Panel_Controls.Visible
                PanelControlsShowHide()
                Return
            End If
        End If
        MyBase.WndProc(m)
    End Sub

    ' ====================================================================================================
    '  Params
    ' ====================================================================================================
    Private FirstSlot As Int32
    Private NumSlots As Int32
    Private MaxValue As Int32
    Private MinValue As Int32
    Friend Colors As Int32
    Friend StringViewer As Boolean
    Private Decimals As Int32
    Private RepeatDelay As Int32
    Private RepeatTime As Int32
    Private ClickEnabled As Boolean

    Private Sub chk_StringSlots_CheckedChanged(ByVal Sender As Object, ByVal e As System.EventArgs) _
                                                                         Handles chk_StringSlots.CheckedChanged
        If Not EventsAreEnabled Then Exit Sub
        SuspendRedraw(Me)
        InitStringType()
        InitParams()
        Save_INI()
        SlotBars_Show()
        ResumeRedraw(Me)
        Save_INI()
    End Sub

    Private Sub InitStringType()
        StringViewer = chk_StringSlots.Checked
        lbl_MaxValue.Visible = Not StringViewer
        txt_MaxValue.Visible = Not StringViewer
        lbl_MinValue.Visible = Not StringViewer
        txt_MinValue.Visible = Not StringViewer
        lbl_Decimals.Visible = Not StringViewer
        txt_Decimals.Visible = Not StringViewer
        If StringViewer Then
            Panel_Controls.Height = 130
            ' TODO - Change taskbar icon not working
            'Me.ShowInTaskbar = False
            'Me.Icon = My.Resources.SlotViewerStrings
            'Me.ShowInTaskbar = True
        Else
            Panel_Controls.Height = 148 + 16
            'Me.ShowInTaskbar = False
            'Me.Icon = My.Resources.SlotViewer
            'Me.ShowInTaskbar = True
        End If
    End Sub


    Private Sub Params_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) _
                                                            Handles txt_FirstSlot.LostFocus, _
                                                                    txt_NumSlots.LostFocus, _
                                                                    txt_MaxValue.LostFocus, _
                                                                    txt_MinValue.LostFocus, _
                                                                    txt_Decimals.LostFocus, _
                                                                    txt_RowsPerCol.LostFocus, _
                                                                    txt_Zoom.LostFocus, _
                                                                    chk_StringSlots.LostFocus, _
                                                                    chk_Selective.LostFocus, _
                                                                    chk_Locked.LostFocus
        Save_INI()
    End Sub
    Private Sub txt_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) _
                                                            Handles txt_FirstSlot.TextChanged, _
                                                                    txt_NumSlots.TextChanged, _
                                                                    txt_MaxValue.TextChanged, _
                                                                    txt_MinValue.TextChanged, _
                                                                    txt_Decimals.TextChanged, _
                                                                    txt_RowsPerCol.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        InitParams()
        Save_INI()
    End Sub

    Private Sub txt_Zoom_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) _
                                                    Handles txt_Zoom.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        Me.Width = CInt(Me.Width * (txt_Zoom.NumericValue + 24) / (oldzoom + 24))
        oldzoom = txt_Zoom.NumericValue
        InitParams()
        Save_INI()
    End Sub

    Private Sub chk_Colors_CheckedChanged(ByVal Sender As System.Object, ByVal e As System.EventArgs) _
                                                            Handles chk_Colors.CheckedChanged
        Colors += 1
        If Colors > 3 Then Colors = 0
        InitParams()
        Save_INI()
        chk_Colors.Checked = False
    End Sub
    Private Sub chk_EditSlotNames_CheckedChanged(ByVal Sender As System.Object, ByVal e As System.EventArgs) _
                                                             Handles chk_EditSlotFile.CheckedChanged
        Me.Opacity = 0.7
        Dim fname As String = GetSlotFilePathAndName
        CreateFile_IfNotExists_AndWithoutLockingIt(fname)
        ProcessStartAndWait(fname)
        chk_EditSlotFile.Checked = False
        Me.Opacity = 1
        SlotBars_Show()
        SetSlotBarsLeftTextSize()
    End Sub

    Friend Sub CreateFile_IfNotExists_AndWithoutLockingIt(ByVal fname As String)
        If Not My.Computer.FileSystem.FileExists(fname) Then
            Dim fs As IO.FileStream
            fs = New IO.FileStream(fname, _
                                   IO.FileMode.Create, _
                                   IO.FileAccess.Write, _
                                   IO.FileShare.ReadWrite)
            fs.Close()
        End If
    End Sub

    Private Sub chk_Selective_CheckedChanged(ByVal Sender As System.Object, ByVal e As System.EventArgs) _
                                                             Handles chk_Selective.CheckedChanged
        SuspendRedraw(Me)
        SlotBarsArray_Clear()
        InitParams()
        ResumeRedraw(Me)
        Save_INI()
    End Sub

    Private Sub InitParams()
        ' -------------------------------------------------------------------------
        SlotBarsHeight = 22 + txt_Zoom.NumericValueInteger - 10
        ' ------------------------------------------------------------------------- set params
        UnselectAllSlotBars()
        FirstSlot = txt_FirstSlot.NumericValueInteger
        NumSlots = txt_NumSlots.NumericValueInteger
        txt_FirstSlot.MaxValue = 1000 - NumSlots
        txt_NumSlots.MaxValue = Math.Min(1000 - FirstSlot, 999)
        ' -------------------------------------------------------------------------
        MaxValue = txt_MaxValue.NumericValueInteger
        MinValue = txt_MinValue.NumericValueInteger
        Decimals = txt_Decimals.NumericValueInteger
        NumBarsPerColumn = txt_RowsPerCol.NumericValueInteger
        ' ------------------------------------------------------------------------- show
        SlotBars_Show()
        EventsAreEnabled = False
        Dim oldW As Int32 = Me.Size.Width
        Dim oldH As Int32 = Me.Size.Height
        Dim nbars As Int32 = NumSlots
        If NumVisibleBars > 0 Then nbars = NumVisibleBars
        If MaxVerticalPosition < nbars Then nbars = MaxVerticalPosition
        ' ------------------------------------------------------------------------- if not minimized then set limits
        If Me.WindowState = FormWindowState.Normal Then
            ' --------------------------------------------------------------------- allow any resize
            Dim MinWidth As Int32 = 215
            Dim MinHeight As Int32 = Panel_Controls.Bottom + SystemInformation.CaptionHeight + 20
            Me.MaximumSize = New Size(9000, 9000)
            Me.MinimumSize = New Size(MinWidth, MinHeight)
            ' --------------------------------------------------------------------- resize and limit the form
            Me.ClientSize = New Size(Me.ClientSize.Width, 9 + nbars * SlotBarsHeight)
            Me.MaximumSize = New Size(9000, Me.Size.Height)
            Me.MinimumSize = New Size(MinWidth + 2, Me.Size.Height)
        End If
        EventsAreEnabled = True
        ' -------------------------------------------------------------------------- to overcome Linux position error
        If Not OperatingSystemIsWindows Then Panel_Controls.Left = -2
        PanelDummy.SendToBack()
        ' -------------------------------------------------------------------------- 
        SetSlotBarsLeftTextSize()
    End Sub

    ' ====================================================================================================
    '  Timer
    ' ====================================================================================================
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        PollSlots()
        TestSlotFile()
    End Sub
    Private Sub PollSlots()
        If StringViewer Then
            For i As Int32 = 0 To SlotBars.Length - 1
                If SlotBars(i) Is Nothing Then Continue For
                SlotBars(i).SetStringValue(Theremino_Strings.StringSlots.ReadString(SlotBars(i).GetSlotIndex))
            Next
        Else
            For i As Int32 = 0 To SlotBars.Length - 1
                If SlotBars(i) Is Nothing Then Continue For
                SlotBars(i).SetValue(Slots.ReadSlot(SlotBars(i).GetSlotIndex))
            Next
        End If
    End Sub


    ' ====================================================================================================
    '  ArrowUp / ArrowDown / Pageup / PageDown and MouseWheel 
    ' ====================================================================================================
    Private Sub Form1_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyDown
        If Locked Then Return
        Dim n As Single
        Select Case e.KeyCode
            Case Keys.Up : ChangeSelectedSlotBar(-1)
            Case Keys.Down : ChangeSelectedSlotBar(1)
            Case Keys.Right : n = 1
            Case Keys.Left : n = -1
            Case Keys.PageUp : n = 10
            Case Keys.PageDown : n = -10
            Case Keys.Escape : UnselectAllSlotBars()
        End Select
        If StringViewer Then
            If SelectedSlotBar IsNot Nothing Then SelectedSlotBar.EditText(e.KeyCode)
        Else
            If e.Shift Then n *= 100
            If e.Control Then n *= 10
            If e.Alt Then n /= 10
            If SelectedSlotBar IsNot Nothing Then SelectedSlotBar.DeltaValue(n)
        End If
    End Sub
    Private Sub Form1_MouseWheel(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseWheel
        If Locked Then Return
        Dim n As Single = CInt(e.Delta / 1.2)
        If SelectedSlotBar IsNot Nothing Then SelectedSlotBar.DeltaValue(n)
    End Sub

    Private SelectedSlotBar As SlotBar
    Friend Sub SetSelectedSlotBar(ByRef sbar As SlotBar)
        If Locked Then Return
        If sbar Is Nothing Then Return
        '
        If SelectedSlotBar IsNot Nothing Then
            SelectedSlotBar.Selected = False
            SelectedSlotBar.ShowValue()
        End If
        SelectedSlotBar = sbar
        SelectedSlotBar.Selected = True
        SelectedSlotBar.ShowValue()
        '
        PanelDummy.Focus()
    End Sub

    Private Sub ChangeSelectedSlotBar(ByRef delta As Int32)
        If SelectedSlotBar Is Nothing Then Return
        Dim index As Int32
        index = GetSlotBarArrayIndex(SelectedSlotBar)
        index += delta
        If index >= 0 And index <= SlotBars.Length - 1 Then
            SetSelectedSlotBar(SlotBars(index))
        End If
    End Sub

    Private Sub UnselectAllSlotBars()
        For i As Int32 = 0 To SlotBars.Length - 1
            If SlotBars(i) IsNot Nothing Then
                SlotBars(i).Selected = False
            End If
        Next
    End Sub

    Private Function GetSlotBarArrayIndex(ByVal sb As SlotBar) As Int32
        For i As Int32 = 0 To SlotBars.Length - 1
            If sb Is SlotBars(i) Then
                Return i
            End If
        Next
    End Function


    ' ==============================================================================================================
    '   ToolTips
    ' ==============================================================================================================
    Private ttp1 As ToolTip
    Private Sub ToolTips_Init()
        ttp1 = New ToolTip
        ttp1.ShowAlways = True
        ttp1.UseAnimation = True
        ttp1.UseFading = True
        ttp1.IsBalloon = True
        ttp1.AutoPopDelay = 32700
        ttp1.InitialDelay = 700
        ttp1.ReshowDelay = 500
        ' --------------------------------------------------------------- Add here Controls and ToolTip-Text
        ttp1.SetToolTip(txt_FirstSlot, _
                        " First slot" & vbCrLf & _
                        " - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -" & vbCrLf & _
                        " The index of the first slot." & vbCrLf & vbCrLf & _
                        " Press the left mouse button and move mouse Up and Down" & vbCrLf & _
                        " or use the mouse wheel to trim this value.")

        ttp1.SetToolTip(txt_NumSlots, _
                        " Number of slots" & vbCrLf & _
                        " - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -" & vbCrLf & _
                        " The number of the consecutive slots." & vbCrLf & vbCrLf & _
                        " Press the left mouse button and move mouse Up and Down" & vbCrLf & _
                        " or use the mouse wheel to trim this value.")

    End Sub
    ' --------------------- this corrects the XP bug that causes tooltip disappearing for ever 
    Private Sub controls_MouseEnter(ByVal sender As Object, _
                                   ByVal e As System.EventArgs) Handles txt_FirstSlot.MouseEnter, _
                                                                        txt_NumSlots.MouseEnter
        ttp1.Active = False
        ttp1.Active = True
    End Sub


    ' ==============================================================================================================
    '   LOCKED / UNLOCKED
    ' ==============================================================================================================
    Private Locked As Boolean = False
    Private Sub EnableDisableControls()
        Locked = chk_Locked.Checked
        chk_StringSlots.Enabled = Not Locked
        txt_FirstSlot.Enabled = Not Locked
        txt_NumSlots.Enabled = Not Locked
        txt_MaxValue.Enabled = Not Locked
        txt_MinValue.Enabled = Not Locked
        txt_Decimals.Enabled = Not Locked
        txt_Zoom.Enabled = Not Locked
        chk_Colors.Enabled = Not Locked
        chk_EditSlotFile.Enabled = Not Locked
        chk_Selective.Enabled = Not Locked
        If Locked Then
            BackColor = Color.FromArgb(210, 255, 210)
        Else
            BackColor = Color.LightYellow
        End If
    End Sub

    Private Sub chk_Locked_CheckedChanged(ByVal Sender As Object, ByVal e As System.EventArgs) _
                                                                   Handles chk_Locked.CheckedChanged
        EnableDisableControls()
        ' --------------------------------------------------------------------- show
        SlotBars_Show()
        PanelDummy.SendToBack()
    End Sub


    ' ====================================================================================================
    '  SlotBars
    ' ====================================================================================================
    Private SlotBarsHeight As Int32 = 22 - 4
    Private SlotBars(-1) As SlotBar

    Private Sub SlotBarsArray_Clear()
        For i As Int32 = 0 To SlotBars.Length - 1
            If SlotBars(i) IsNot Nothing Then SlotBars(i).Destroy()
        Next
        ReDim SlotBars(-1)
    End Sub

    Friend Sub SlotBars_Show()
        ' ------------------------------------------------------------ load slot names
        LoadSlotNames()
        ' ------------------------------------------------------------ select type
        If chk_Selective.Checked And ValidSlotNames Then
            SlotBars_ShowPartial()
        Else
            SlotBars_ShowTotal()
            chk_Selective.Checked = False
        End If
    End Sub

    Private NumBarsPerColumn As Int32 = 100
    Private NumVisibleBars As Int32
    Private MaxVerticalPosition As Int32
    Private NumColumns As Int32 = 5

    Private Sub UpdateNumColumns()
        NumColumns = 0
        NumVisibleBars = 0
        For i As Int32 = FirstSlot To 1000
            If i < SlotNames.Length Then
                '
                Dim opt As SlotNamesOptions = ExtractSlotNamesOptions(i, MinValue, MaxValue)
                If Not opt.Visible Then Continue For
                '
                ' --------------------------------------------------- Compute Column and Reset VerticalPosition
                Dim column As Int32 = (i - FirstSlot) \ NumBarsPerColumn + 1
                If column > NumColumns Then
                    NumColumns = column
                End If
                '
                NumVisibleBars += 1
                If NumVisibleBars >= NumSlots Then Exit For
            End If
        Next
        If NumColumns < 1 Then NumColumns = 1
    End Sub

    Private Sub SlotBars_ShowPartial()
        ' ------------------------------------------------------------ 
        UpdateNumColumns()
        ' ------------------------------------------------------------ 
        Dim OldColumn As Int32
        Dim VerticalPosition As Int32
        NumVisibleBars = 0
        MaxVerticalPosition = 0
        ' ------------------------------------------------------------ 
        SuspendRedraw(Me)
        ' ------------------------------------------------------------ clear bars
        SlotBarsArray_Clear()
        ReDim SlotBars(NumSlots - 1)
        ' ------------------------------------------------------------ prepare params
        Dim barsLeft As Int32 = Panel_Controls.Right
        Dim SlotBarsWidth As Int32 = (Me.ClientSize.Width - barsLeft) \ NumColumns - 4

        For i As Int32 = FirstSlot To 999
            '
            If i < SlotNames.Length Then
                '
                Dim opt As SlotNamesOptions = ExtractSlotNamesOptions(i, MinValue, MaxValue)
                If Not opt.Visible Then Continue For
                '
                ' --------------------------------------------------- Compute Column and Reset VerticalPosition
                Dim column As Int32 = (i - FirstSlot) \ NumBarsPerColumn
                If column > OldColumn Then
                    OldColumn = column
                    VerticalPosition = 0
                End If
                '
                ' --------------------------------------------------- Create the SlotBar
                SlotBars(NumVisibleBars) = New SlotBar(Me)
                SlotBars(NumVisibleBars).SetLockedStatus(Locked)
                SlotBars(NumVisibleBars).SetSlotIndex(i)
                SlotBars(NumVisibleBars).SetText(opt.Text)
                '
                SlotBars(NumVisibleBars).SetAspectParams(barsLeft + column * (SlotBarsWidth + 4), _
                                                         5 + VerticalPosition * SlotBarsHeight, _
                                                         SlotBarsWidth, _
                                                         SlotBarsHeight, _
                                                         StringViewer, _
                                                         opt.Max, _
                                                         opt.Min, _
                                                         Colors, Decimals)
                '
                ' --------------------------------------------------- Update
                NumVisibleBars += 1
                VerticalPosition += 1
                ' --------------------------------------------------- Update the MaxVerticalPosition
                If VerticalPosition > MaxVerticalPosition Then
                    MaxVerticalPosition = VerticalPosition
                End If
                ' --------------------------------------------------- Exit if...
                If NumVisibleBars >= NumSlots Then Exit For
            End If
            '
        Next
        ' ------------------------------------------------------------ draw bars
        For i As Int32 = 0 To SlotBars.Length - 1
            If SlotBars(i) Is Nothing Then Continue For
            SlotBars(i).ShowValue()
        Next
        ' ------------------------------------------------------------ 
        PanelDummy.SendToBack()
        PollSlots()
        ResumeRedraw(Me)
        Refresh()
    End Sub

    Private Sub SlotBars_ShowTotal()
        MaxVerticalPosition = 9999
        ' ------------------------------------------------------------ 
        SuspendRedraw(Me)
        ' ------------------------------------------------------------ add remove bars
        If SlotBars Is Nothing OrElse NumSlots > SlotBars.Length Then
            Dim oldlen As Int32 = SlotBars.Length
            ReDim Preserve SlotBars(NumSlots - 1)
            For i As Int32 = oldlen To SlotBars.Length - 1
                SlotBars(i) = New SlotBar(Me)
            Next
        ElseIf NumSlots < SlotBars.Length Then
            For i As Int32 = NumSlots To SlotBars.Length - 1
                SlotBars(i).Destroy()
            Next
            ReDim Preserve SlotBars(NumSlots - 1)
        End If
        ' ------------------------------------------------------------ prepare params
        Dim barsLeft As Int32 = Panel_Controls.Right
        NumVisibleBars = 0
        For i As Int32 = 0 To SlotBars.Length - 1
            If SlotBars(i) Is Nothing Then Continue For

            Dim opt As SlotNamesOptions = ExtractSlotNamesOptions(FirstSlot + i, MinValue, MaxValue)

            SlotBars(i).SetLockedStatus(Locked)
            SlotBars(i).SetSlotIndex(FirstSlot + i)
            SlotBars(i).SetText(opt.Text)

            SlotBars(i).SetAspectParams(barsLeft, _
                                        5 + i * SlotBarsHeight, _
                                        Me.ClientSize.Width - barsLeft - 4, _
                                        SlotBarsHeight, _
                                        StringViewer, _
                                        opt.Max, _
                                        opt.Min, _
                                        Colors, Decimals)
        Next
        ' ------------------------------------------------------------ draw bars
        For i As Int32 = 0 To SlotBars.Length - 1
            If SlotBars(i) Is Nothing Then Continue For
            SlotBars(i).ShowValue()
        Next
        ' ------------------------------------------------------------ 
        PanelDummy.SendToBack()
        PollSlots()
        ResumeRedraw(Me)
        Refresh()
    End Sub

    Private Sub SetSlotBarsLeftTextSize()
        If Not StringViewer Then Return
        If SlotBars.Length = 0 Then Return
        NumVisibleBars = 0
        SlotBar.LeftTextSize = 0
        If chk_Selective.Checked And ValidSlotNames Then
            For i As Int32 = FirstSlot To 999
                '
                If i < SlotNames.Length Then
                    '
                    Dim opt As SlotNamesOptions = ExtractSlotNamesOptions(i, MinValue, MaxValue)
                    If Not opt.Visible Then Continue For
                    '
                    If SlotBars(NumVisibleBars) Is Nothing Then Continue For
                    '
                    SlotBars(NumVisibleBars).UpdateLeftTextSize()
                    '
                    NumVisibleBars += 1
                    If NumVisibleBars >= NumSlots Then Exit For
                End If
                '
            Next
        Else
            For i As Int32 = 0 To SlotBars.Length - 1
                If SlotBars(i) Is Nothing Then Continue For
                SlotBars(i).UpdateLeftTextSize()
            Next
        End If
        SlotBars_Show()
    End Sub

End Class